c
	subroutine startup
c
c	subroutine to get initial data for gfit
c
c	routine reads in initial file and parameters from a startup file
c	with extension .fit
c
c	parameters are
c
c	directory
c	file
c	ipmin,ipmax,ivtic   for  display
c	ihmin,ihmax,ihtic   for display
c	baseline constant
c	type of continuum   g gauss  p polynomial   n none
c       p1,p2,p3  for continuum
c	number of bands
c	center in nm   fwhm in inverse cm    intensity
c	center in nm   fwhm in inverse cm    intensity
c	center in nm   fwhm in inverse cm    intensity
c	etc
c
	common/misc/volt,slope,const,swav1,swav2
c
	common/databl/ RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 gauss(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536),daterr(1536)
c
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	common/errors/rmsold,rmsnew,rmsimp,rmslim,rimplim
c
	common/roots/wvrt(1536),cnrt(30),sgrt(30),sgsq(30)
c
	REAL*4 SAMP,STAND,BGND,SIG,SD1,SD2,TIMINT
	real scent(90),sfwhm(90),sstr(90),sp0,sp1,sp2,sp3
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
	real*8 g(1536,94)
C
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC
	LOGICAL*1 TITLE(50),DISPD,dispi
	logical*1 disps,dispf,disprs,dispg,dispc,disprm,contyp
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2
C
	INTEGER*2 LSTBYT,IOUNIT,IBLK,IOERR
	LOGICAL*1 TXTIN(72),BLOCK(512)
	LOGICAL*1 ITIME(8),YES,NO,ANSWERS(12)
	LOGICAL*1 IHY,IHN,IHX,IB,IDATE(9),ESCAPE
	LOGICAL*1 TEXT(72,16)
	LOGICAL*1 DOT,DBYTE,ABYTE,TBYTE
	LOGICAL*1 STB(6)   ! SIDERIAL TIM HHMMSS
C
	CHARACTER FILNAM*10,EXT*4,FILEIN*40,FIRST*1,DIRECT*24,
	2 FEXT*4,START*14
C
C	SET UP EQUIVALENCES FOR HAWAII DATA
C
	EQUIVALENCE (ID1,IREVS),(ID2,ITIMCH),(IRESL,NRUNS),
	2(SANGLE,XNRM),(DANGLE,SCATIM),(IPOLAR,IHTYP)
	DATA IBELL/7/
	DATA YES,NO,IHX/'Y','N',1HX/
C
C
C
	wconst=2.354820
c
c	call init_io   ! get io channel
	call vtcom     ! set up escape seq
5	call clrscr
C
	EXT='.DAT'
	FEXT='.FIT'
c
11	WRITE(*,7050)
7050	FORMAT(/' Enter Startup File Name: '$)
	READ(*,7060)START
7060	FORMAT(A24)
	IF(START.EQ.'  ')GOTO 11
C
C	OPEN UP THE STARTUP FILE AND READ IN THE DATA FILE NAME
C
	IOUNIT=2
	FILEIN=START//FEXT
	OPEN(UNIT=IOUNIT,STATUS='OLD',FILE=FILEIN,ACCESS='SEQUENTIAL',
	2 ERR=11,FORM='FORMATTED',READONLY)
c
	READ(2,7302)DIRECT
	READ(2,7300)FILNAM
	FILEIN=DIRECT//FILNAM//EXT
	FIRST=FILNAM (1:1)
7300	FORMAT(A10)
7302	FORMAT(A24)
C
C	READ IN THE OTHER PARAMETERS
C
	READ(2,*)IPMIN,IPMAX,IVTIC
	READ(2,*)IWMIN,IWMAX,IHTIC
	READ(2,*)RMSLIM,RIMPLIM
	READ(2,7300)CONTYP
	CALL LOW2UP(CONTYP)
C
	READ(2,*)CP0,CP1,CP2,CP3
	READ(2,*)sP0,sP1,sP2,sP3
C
	IF(CONTYP.EQ.'S')SWAV1=CP0
	IF(CONTYP.EQ.'S')SWAV2=CP1
	IF(CONTYP.EQ.'T')SWAV1=CP0
	IF(CONTYP.EQ.'T')SWAV2=CP1
C
	READ(2,*)NBANDS
C	WRITE(*,*)NBANDS
C
	DO 30 K=1,NBANDS
	READ(2,*)GCENT(K),GFWHM(K),GSTR(K)
	READ(2,*)sCENT(K),sFWHM(K),sSTR(K)
C	WRITE(*,*)GCENT(K),GFWHM(K),GSTR(K)
30	CONTINUE
	CLOSE(UNIT=2)               ! END OF STARTUP PARAMETERS	 
	nparam=3*NBANDS
c
c	create cmm diagonals from est. model stnd dev.
c
	DO 50 K=1,NBANDS
	  sCENT(K)=WLTOWN(gcent(k)-sCENT(K))-WLTOWN(gcent(k)+sCENT(K))
	  sFWHM(K)=sFWHM(K)/WCONST
50	CONTINUE
C
C	FILL THE PARAM ARRAY
C	1-NBANDS ARE CENTERS
C	NBANDS+1 - 2NBANDS ARE WIDTHS
C	2NBANDS+1 - 3BANDS ARE STRENGTHS
C
	DO 501 K=1,NBANDS
	cmm(K)=sCENT(K)	
	cmm(NBANDS+K)=sfwhm(K)
	cmm(NBANDS+NBANDS+K)=sSTR(K)
501	CONTINUE
C
	cmm(NPARAM+1)=sP0
	cmm(NPARAM+2)=sP1
	cmm(NPARAM+3)=sP2
	cmm(NPARAM+4)=sP3
c
	call filstat                ! fill in the types of partials
c
c	unlock all parameters
c
	do 35 k=1,nparam
	ipstat(k,1)=0        ! unlocked
35	continue
c
c	ipstat(nparam+1,1)=1
c	ipstat(nparam+2,1)=1
c	ipstat(nparam+3,1)=1 ! lock continuum stuff
c	ipstat(nparam+4,1)=1
C
C	NOW READ IN FILE AND WRITE OUT TEXT
C
10	DFLAG=4
	IDPOLR=3
	IERROR=0
C
	CALL DATE(IDATE)
C
	call clrscr
c
	CALL TIME(ITIME)
	GOTO 20
c
777	CALL ERRSUB
	CLOSE(UNIT=IOUNIT,DISP='KEEP')
	RETURN
C
C-----GET SOURCE DATA
C
20	CONTINUE
C
	FILEIN=DIRECT//FILNAM//EXT
	FIRST=FILNAM (1:1)
C
	IBLK=1
	IOUNIT=1
	OPEN(UNIT=IOUNIT,STATUS='OLD',FILE=FILEIN,ACCESS='DIRECT',
	2 ERR=777,FORM='UNFORMATTED',RECL=128,READONLY)
	READ(IOUNIT'IBLK)BLOCK   ! READ FIRST BLOCK
C
	CALL HDBAK1(BLOCK,LSTBYT,NPNTS,IDATE,ITIME,IRANGE,IRESL,
	2 ID1,ID2,SCLMAX,IPOLAR,SANGLE,DANGLE,LINE,VOLT)
C
C-----FLAG STORED IN THIRD DECIMAL PLACE OF "VOLT" TO SELECT
C-----ADDITIONAL READ STATEMENT FOR DATA BASE TYPE TWO
C
	IF(VOLT.EQ.0.111)CALL HDBAK3(BLOCK,LSTBYT,IRAH,IRAM,IRAS,
	2 IDEG,IDEM,IDES,IAIR,IERROR,TIMINT,STB)
C
	IF(VOLT.NE.0.111)CALL HDBAK2(BLOCK,LSTBYT,IDTECT,IGRAT,
	2 ISCAN,ILITE,BGND,SIG,SD1,SD2,ETIME)
C
8000	FORMAT(Q,72A1)
	DO 90 J=1,LINE
	CALL TXTBAK(IOUNIT,IBLK,BLOCK,IOERR,LSTBYT,TXTIN)
	IF(IOERR.EQ.1)GOTO 777
C
	DO 95 J2=1,72
95	TEXT(J2,J)=TXTIN(J2)
C
90	CONTINUE
C
	DO 120 J=1,NPNTS
	CALL DATBAK(IOUNIT,IBLK,BLOCK,IOERR,LSTBYT,VOLT,
	2 LAMDA,RATIO(J),SAMP,STAND,daterr(j))
C
	if(daterr(j).ne.0.0)daterr(j)=1/daterr(j)
	RATIO(J)=LOG(RATIO(J))                      ! CONVERT TO LOG REF
	WAVEL(J)=LAMDA                              ! CONVERT TO FLOAT
	IF(ISCAN.EQ.1)WAVEL(J)=wavel(J)/10.         ! CONVERT ang to microns
	IF(ISCAN.NE.3)WAVEN(J)=WLTOWN(WAVEL(J))     ! CONVERT TO WAVENUMBER
	IF(ISCAN.EQ.3)WAVEN(J)=WAVEL(J)             ! ALREADY CONVERTED
	IF(IOERR.EQ.1)GOTO 777
120	CONTINUE
C
	CLOSE(UNIT=IOUNIT,DISP='KEEP')
C
	if(iscan.eq.1)irange(1)=irange(1)/10
	if(iscan.eq.1)irange(2)=irange(2)/10
	if(iscan.eq.1)iscan=2    ! data was converted from ang to microns
	DO 197 J1=1,50
	TITLE(J1)=TEXT(J1,1)
197	CONTINUE
C
C-----PLOT RESULTS ON VT55
C
750	call clrscr
C
	CALL TIME(ITIME)
C
	WRITE(*,9000)IDATE,ITIME
	WRITE(*,755)FILNAM
9000	FORMAT(//1X,9A1,12X,'=== Reflectance Data '
	1 ,'Re-Plot ===',11X,8A1,//)
755	FORMAT(' File Name:  ',A10)
	IF(VOLT.EQ.0.111)GOTO 1201  ! SPECPR FILE
	IF(ISCAN.EQ.2)WRITE(*,9100)IRANGE,IRESL
	IF(ISCAN.EQ.1)WRITE(*,9102)IRANGE,IRESL
	WRITE(*,9104)ID1,ID2,VOLT
9100	FORMAT(11X,' Range (Nanometers):',I5,' To'
	2I5,/19X' Resolution:'I3)
9102	FORMAT(11X,' Range (Angstroms) :'I5' To'I5
	2/19X' Resolution:'I3)
9104	FORMAT(2X' Normal Dwell Time 
    	2(Seconds):',I3,/' Extended Dwell Time (Seconds):'
	3,I3,/5X,' Delta Dwell Time Voltage:  ',F5.3)
	IF(VOLT.EQ.0.222)GOTO 797  ! WASH FILE SKIP TO TEXT
	IF(IGRAT.EQ.1)IFLGG=1180
	IF(IGRAT.EQ.2)IFLGG=590
	IF(IGRAT.EQ.3)IFLGG=295
	IF(IGRAT.EQ.4)IFLGG=147
	IF(IDTECT.EQ.1)WRITE(*,9105)
9105	FORMAT(21X,' Detector: PMT')
	IF(IDTECT.EQ.2)WRITE(*,9111)
9111	FORMAT(21X,' Detector: INSB')
9115	WRITE(*,9116)IFLGG,BGND,SD2,SIG,SD1
9116	FORMAT(22X,' Grating:',I5,//13X,' Background Noise:'
	1,F7.2,/4X,' Standard Deviation (X100):',F7.2,/13X,' Reference
	2 Signal:',F7.2,/4X,' Standard Deviation 
	3(X100):',F7.2/)
	WRITE(*,9120)SANGLE,DANGLE
9120	FORMAT(17X,' Source Angle:',F7.2,/15X,' Detector Angle:',F7.2)
9150	CONTINUE
c
797	WRITE(*,790) ((TEXT(I,J),I=1,72),J=1,LINE)
790	FORMAT(2X,72A1)
	READ(*,5001)IDUM
5001	format(I1)
	GO TO 710
C
C	WRITE OUT DATA ON SCREEN FOR HAWAII FILE
C
1201	WRITE(*,7000)IRANGE,NRUNS,IREVS,SCATIM,TIMINT
7000	FORMAT(10X'             Scan Range: 'I4' To 'I4 /
	210X      '              # Of Runs: 'I3/
	210X      '          Scans per Run: 'I3/
	210X      '          Time per Scan: 'F6.2/
	210X      ' Total Integration Time:'F8.2/)
	WRITE(*,7010)IRAH,IRAM,IRAS,IDEG,IDEM,IDES,IAIR,XNRM
7010	FORMAT(10X'        Right Ascension: 'I3':'I3':'I3/
	210X      '            Declination: 'I3':'I3':'I3/
	210X      '               Air Mass: 'I4/
	28X      'Band Normalization Factor: 'F9.6/)
	IF(IHTYP.EQ.1)WRITE(*,7012)
	IF(IHTYP.EQ.2)WRITE(*,7014)
	IF(IHTYP.EQ.3)WRITE(*,7016)
	IF(IHTYP.EQ.4)WRITE(*,7018)
7012	FORMAT(15X'         File Type:  Sun'/)
7014	FORMAT(15X'         File Type:  Apollo 16'/)
7016	FORMAT(15X'         File Type:  MS 2'/)
7018	FORMAT(15X'         File Type:  Continuum'/)
	GOTO 797
710	CONTINUE
C
C	SET CLEAR POLYNOMIAL PARAMETERS
C
	IF(CONTYP.EQ.'P')GOTO 1000     ! polynomial in wavelength space
	IF(CONTYP.EQ.'Q')GOTO 1600     ! polynomial in wavenumber space
	IF(CONTYP.EQ.'S')GOTO 1300     ! STRAIGHT LINE REMOVAL IN WAVEL SPACE
	IF(CONTYP.EQ.'T')GOTO 1500     ! STRAIGHT LINE IN WAVEN SPACE
C
C	NO CONTINUUM	
C
	DO 800 K=1,NPNTS
	CONT(K)=0.0
800	CONTINUE
	GOTO 1400
C
C	POLYNOMIAL CONT IN WAVELENGTH SPACE
C
1000	continue
	do 1050 k=1,npnts
	W=WAVEL(K)
	WS=W*W
	WC=W*WS
	CONT(K)=CP0+(CP1*W)+(CP2*WS)+(CP3*WC)
	cont(k)=log(cont(k))
1050	CONTINUE
	GOTO 1400
C
C	POLYNOMIAL CONT IN WAVENUMBER SPACE
C
1600	continue
	do 1650 K=1,npnts
	W=WAVEN(K)
	WS=W*W
	WC=W*WS
	CONT(K)=CP0+(CP1*W)+(CP2*WS)+(CP3*WC)
	cont(k)=log(cont(k))
1650	CONTINUE
	GOTO 1400
C
C	STRAIGHT LINE CONTINUUM REMOVAL IN WAVELENGTH SPACE
C
1300	CALL SREMOVE(NPNTS,SWAV1,SWAV2,WAVEL,RATIO)
	CP0=CONST
	CP1=SLOPE
	CP2=0.0
	CP3=0.0
C
	DO 1310 K=1,NPNTS
	W=WAVEL(K)
	WS=W*W
	WC=W*WS
	CONT(K)=CP0+(CP1*W)+(CP2*WS)+(CP3*WC)
	cont(k)=log(cont(k))
1310	CONTINUE
C
	GOTO 1400
C
C	STRAIGHT LINE CONTINUUM REMOVAL IN WAVENUMBER SPACE
C
1500	CALL TREMOVE(NPNTS,SWAV1,SWAV2,WAVEN,RATIO)
	CP0=CONST
	CP1=SLOPE
	CP2=0.0
	CP3=0.0
C
	DO 1510 K=1,NPNTS
	W=WAVEN(K)
	WS=W*W
	WC=W*WS
	CONT(K)=CP0+(CP1*W)+(CP2*WS)+(CP3*WC)
	cont(k)=log(cont(k))
1510	CONTINUE
C
	GOTO 1400
C
1400	continue
	CALL FILLUP         ! FILL UP THE ARRAYS
C
	RETURN
	END
C
C	TREMOVE.FOR
C
	SUBROUTINE TREMOVE(NPNTS,WAVS,WAVF,WAVIN,RATIO)
C
C	PROGRAM COMPUTES STRAIGHT LINE AT DESIRED WAVENUMBERS
C
	REAL*4 RATIO(1536),WAVIN(1536),CONT(1536),WAV1,WAV2
	INTEGER*2 NPNTS
c
	common/misc/volt,slope,const,swav1,swav2
c
C
C	FIND THE TWO PTS CLOSEST TO WAV1,WAV2
C
	WAVA=WLTOWN(WAVS)
	WAVB=WLTOWN(WAVF)    ! CONVERT NM TO WNUMBER
C
	DO 100 K=NPNTS,1,-1
	IP1=K
	IF(WAVIN(K).GE.WAVA)GOTO 120   ! JUMP OUT ON EQUAL OR GREATER
100	CONTINUE
120	CONTINUE
C
	DO 130 K=NPNTS,IP1,-1
	IP2=K
	IF(WAVIN(K).GE.WAVB)GOTO 140   ! JUMP OUT ON EQUAL OR GREATER
130	CONTINUE
140	CONTINUE
C
C	NOW BUILD STRAIGHT LINE
C
	RAT1=(RATIO(IP1-1)+RATIO(IP1)+RATIO(IP1+1))/3.0
	RAT2=(RATIO(IP2-1)+RATIO(IP2)+RATIO(IP2+1))/3.0
	WAV1=WAVIN(IP1)
	WAV2=WAVIN(IP2)
	SLOPE=(RAT2-RAT1)/(WAV2-WAV1)   ! CALCULATE M
	C1=RAT1-(SLOPE*WAV1)            ! CALC      C
	C2=RAT2-(SLOPE*WAV2)
	CONST=(C1+C2)/2.0
C
	RETURN
	END
C
C	SREMOVE.FOR
C
	SUBROUTINE SREMOVE(NPNTS,WAVS,WAVF,WAVIN,RATIO)
C
C	PROGRAM COMPUTES STRAIGHT LINE AT DESIRED WAVELENGTHS
C
	REAL*4 RATIO(1536),WAVIN(1536),CONT(1536),WAV1,WAV2
	INTEGER*2 NPNTS
c
	common/misc/volt,slope,const,swav1,swav2
c
C
C	FIND THE TWO PTS CLOSEST TO WAV1,WAV2
C
	DO 100 K=1,NPNTS
	IP1=K
	IF(WAVIN(K).GE.WAVS)GOTO 120   ! JUMP OUT ON EQUAL OR GREATER
100	CONTINUE
120	CONTINUE
C
	DO 130 K=IP1,NPNTS
	IP2=K
	IF(WAVIN(K).GE.WAVF)GOTO 140   ! JUMP OUT ON EQUAL OR GREATER
130	CONTINUE
140	CONTINUE
C
C	NOW BUILD STRAIGHT LINE
C
	RAT1=(RATIO(IP1-1)+RATIO(IP1)+RATIO(IP1+1))/3.0
	RAT2=(RATIO(IP2-1)+RATIO(IP2)+RATIO(IP2+1))/3.0
	WAV1=WAVIN(IP1)
	WAV2=WAVIN(IP2)
	SLOPE=(RAT2-RAT1)/(WAV2-WAV1)   ! CALCULATE M
	C1=RAT1-(SLOPE*WAV1)            ! CALC      C
	C2=RAT2-(SLOPE*WAV2)
	CONST=(C1+C2)/2.0
C
	RETURN
	END
