c
	subroutine stocFIT(ISAMPRES,ITIMES)
c
c	subroutine to CALCULATE BEST FIT
c          using stochastic non-linear inverse
c          Tarantola & Vallete (1982) Reviews in Geophysics
c
	common/misc/volt,slope,const,swav1,swav2
c
	common/databl/ RATIO(1536),WAVEL(1536),WAVEN(1536),
	2 gauss(30,1536),fit(1536),cont(1536),resid(1536),
	2 remain(1536),gline(1536),rcont(1536),daterr(1536)
c
	common/pars/gcent(30),gcentn(30),gfwhm(30),gwidth(30)
	2 ,gstr(30),params(94)
	2 ,ipstat(94,2),param0(94),g,cmm(94)
	2 ,cp0,cp1,cp2,cp3,nparam,nbands,nparus,contyp
c
	common/display/iwmin,iwmax,ihtic,npnts,
	2 iscan,disps,dispf,disprs,dispg,dispc,disprm,dispd,dispi,
	2 title,ipltyp,ilabtyp,ipmin,ipmax,ivtic
c
	common/errors/rmsold,rmsnew,rmsimp,rmslim,rimplim
c
	common/roots/wvrt(1536),cnrt(30),sgrt(30),sgsq(30)
c
	REAL*4 SAMP,STAND,BG,BGND,SIG,SD1,SD2,TIMINT,OLDPAR(94)
	REAL*4 VOLT,SANGLE,DANGLE,SCLMAX,XNRM,SCATIM
	real*8 gtg(94,94),gtgmminv(94,94),indx(94),temp
	real*8 temp1,g(1536,94),mchs(94),mtemp1(94),mtemp2(94)
	real temp2,f(1536),pmin,pmax
	REAL*8 TINV,cmminv(94,94)
C
	integer nparus
	INTEGER*4 IWMIN,IWMAX
	INTEGER*2 IPMIN,IPMAX,IHTIC,IVTIC
	LOGICAL*1 TITLE(50),DISPD,dispi
	logical*1 disps,dispf,disprs,dispg,dispc,disprm,contyp
C
	INTEGER*2 IRESL,IPOLAR,NPNTS,NRUNS,IHTYP,IRANGE(2)
	INTEGER*2 LAMDA,IRAH,IRAM,IRAS,IDEG,IDES,IDEM,IAIR
	INTEGER*2 IDTECT,IGRAT,ILITE,ISCAN,IFLG1,IFLG2,LINE,ID1,ID2
	INTEGER*2 IREVS,ITIMCH,ILABTYP,IPLTYP,DRW1,DRW2
C
	itr=0
	call clrscr
	call shome
c
	fmin=0
	fmax=120
	plt=1
	lbl=1
	tic=20
	FAILURE=1./2.0**15.            ! BACKOFF FAILURE POINT
	WCONST=2.354820
	ISIZE=94
C
10	FACTI=1.0
C
C	SAVE OLDPAR
C
	DO 12 K=1,94
	OLDPAR(K)=PARAMS(K)
12	CONTINUE
C
C	COMPUTE BEST FIT FOR SINGLE BAND
C
	inparam=NPARAM
C
	IF(CP0.NE.0)inparam=inparam+1
	IF(CP1.NE.0)inparam=inparam+1
	IF(CP2.NE.0)inparam=inparam+1
	IF(CP3.NE.0)inparam=inparam+1
C
C	BUILD THE PARTIAL DERIVAIVE MATRIX
C
	NPARUS=0  ! ZERO OUT NUMBER OF PARAMETERS USED
C
	DO 2010 I=1,inparam
C
C	CHECK TO SEE WHICH PARTIAL WE NEED
C
	IF(IPSTAT(I,1).NE.0)GOTO 2010   ! PARAMETER IS NOT UNLOCKED
C
	IPART1=IPSTAT(I,2)    ! SECOND COLUMN CONTAINS DERIVATIVES
	NPARUS=NPARUS+1       ! INCREMENT NUMBER OF PARAMS USED
C
C	FIND OUT WHAT KIND OF DERIVATIVE WE NEED
C
	GOTO (3000,3000,3000,3100,3200,3300,3400)IPART1
C
C	COMPUTE ALL THE PARTIALS 
C
C	IS A BAND WHICH BAND ?
C
3000	IN1=I
	IF(IN1.GT.nbands)IN1=IN1-nbands
	IF(IN1.GT.nbands)IN1=IN1-nbands
C
	DO 2015 K=1,NPNTS,ISAMPRES
	  TINV=GAUSS(IN1,K)
	  g(k,nparus)=PGAUSS(CNRT(IN1),GWIDTH(IN1),GSTR(IN1),WVRT(K),IPART1)
	  g(k,nparus)=g(k,nparus)*TINV
2015	CONTINUE
	GOTO 3600    ! next param
C
C	LINEAR OF POLYNOMIAL
C
3100	DO 3105 K=1,NPNTS,ISAMPRES
	g(k,nparus)=1.0/exp(cont(k))
3105	CONTINUE
	GOTO 3600
C
C	X TERM OF POLYNOMIAL
C
3200	DO 3205 K=1,NPNTS,ISAMPRES
	IF(CONTYP.EQ.'Q'.OR.CONTYP.EQ.'T')g(k,nparus)=WAVEN(K)/exp(cont(k))
	IF(CONTYP.EQ.'P'.OR.CONTYP.EQ.'S')g(k,nparus)=WAVEL(K)/exp(cont(k))
3205	CONTINUE
	GOTO 3600
C
C	X SQUARED TERM OF POLYNOMIAL
C
3300	DO 3305 K=1,NPNTS,ISAMPRES
	IF(CONTYP.EQ.'Q'.OR.CONTYP.EQ.'T')
	2 g(k,nparus)=WAVEN(K)*WAVEN(K)/exp(cont(k))
	IF(CONTYP.EQ.'P'.OR.CONTYP.EQ.'S')
	2	g(k,nparus)=WAVEL(K)*WAVEL(K)/exp(cont(k))
3305	CONTINUE
	GOTO 3600
C
C	X CUBED TERM OF POLYNOMIAL
C
3400	DO 3405 K=1,NPNTS,ISAMPRES
	IF(CONTYP.EQ.'Q'.OR.CONTYP.EQ.'T')
	2 g(k,nparus)=WAVEN(K)*WAVEN(K)*WAVEN(K)/exp(cont(k))
	IF(CONTYP.EQ.'P'.OR.CONTYP.EQ.'S')
	2 g(k,nparus)=WAVEL(K)*WAVEL(K)*WAVEL(K)/exp(cont(k))
3405	CONTINUE
	GOTO 3600
c
3600	continue
2010	CONTINUE
C
c	calculate inv(covariance matrix) for model parameters
c
	do 601 i=1,nparus
	  do 602 j=1,nparus
	    cmminv(i,j)=0.0
 602	  continue
 601	continue
	NR=0
	DO 600 k=1,inparam
	IF(IPSTAT(K,1).NE.0)GOTO 600     ! PARAM IS LOCKED
	NR=NR+1
	  cmminv(nr,nr)=1.0/(cmm(k)/1.96)**2 ! var=(error @95% conf/ 
 600	continue                             ! 1.96)**2
C
C	calculate GTG
C
	do 125 i=1,nparus
	  do 126 j=1,nparus
	    temp=0.0
	    do 127 k=1,npnts
	      temp=temp+(g(k,i)*g(k,j))
 127	    continue
	    gtg(i,j)=temp
 126	  continue
 125	continue
C
	do 400 i=1,nparus
	  gtg(i,i)=gtg(i,i)+cmminv(i,i)  ! gtg + inv(cmm)
 400	continue
C
C	get GTGmminv  inv(gtg + inv(cmm))
C
	do 120 i=1,nparus
	  do 121 j=1,nparus
	    gtgmminv(i,j)=0.0
  121     continue
 	  gtgmminv(i,i)=1.0
 120	continue
	call dludcmp(gtg,nparus,94,indx,d1)
	do 122 j=1,nparus
	  call dlubksb(gtg,nparus,94,indx,gtgmminv(1,J))
 122	continue
c
C	inv(cmm) * differece between model now & original model
c
	NR=0
	DO 403 i=1,inparam
      	  IF(IPSTAT(i,1).NE.0)GOTO 403     ! PARAM IS LOCKED
	  NR=NR+1
	  temp=0.0
	  nr1=0
	  do 404 j=1,inparam
       	     IF(IPSTAT(j,1).NE.0)GOTO 404     ! PARAM IS LOCKED
	     nr1=nr1+1
	     temp=temp+cmminv(nr,nr1)*(oldpar(j)-param0(j))
 404	  continue
          mtemp1(i)=temp
 403	continue
c
C	gt * residual fit
c
	do 411 i=1,nparus
	  temp=0.0
	  do 402 k=1,npnts
	     temp=temp+g(k,i)*resid(k)
 402	  continue
          mtemp2(i)=temp
 411	continue
c
	do 405 i=1,nparus
	  mtemp2(i)=mtemp2(i)-mtemp1(i)
 405	continue
c
c	calculate new model params gtgmminv * mtemp2
c
	do 407 i=1,nparus
	  temp=0.0
	  do 406 j=1,nparus
	     temp=temp+gtgmminv(i,j)*mtemp2(j)
 406	  continue
          mchs(i)=temp
 407	continue
C
	itry=0   ! number of time backoff applied
C
C	FORM NEW SOLUTIONS
C
	ipts=npnts
	rmsold=rmserr(ipts,fit,ratio)   ! get current err
C
C	IF PARAMETER IS UNLOCKED ADD ON CORRECTION
C
	NR=0
	DO 2100 j=1,inparam
	IF(IPSTAT(j,1).NE.0)GOTO 2100     ! PARAM IS LOCKED
	NR=NR+1
	PARAMS(j)=OLDPAR(j)+mchs(NR)
2100	CONTINUE
C
C	NOW MOVE PARAMS BACK TO ORIGINAL ARRAYS
C
2001	continue
c
7420	format(/,'  Band #'I3' has a positive strength !!!'/)
7422	format(/,'  Band #'I3' has a negative width !!!'/)
c
	call unshuffl
c
	call fillup   ! recalulate curve
	ipts=npnts
	rmsnew=rmserr(ipts,fit,ratio)  ! get new error
c
c	see if calculation was an improvement
c
2401	if(rmsnew.ge.rmsold)goto 2402    ! worse off
c
	write(3,7411)
	write(3,7411)
	write(3,7410)cp0,cp1,cp2,cp3
	write(3,7419)nbands
7411	format(/)
7419	FORMAT(1X,I2)
	do 2160 k=1,nbands
2160	write(3,7410)gcent(k),gfwhm(k),gstr(k)	
c
	itr=itr+1
	rmsimp=rmsold-rmsnew
	write(3,7415)rmsold,rmsnew,rmsimp
	write(*,7412)itr,rmsold,rmsnew,rmsimp
7412	format('+ 'I5'   Old RMS'E14.6'   New RMS='E14.6'   Imp='E14.6)
7415	format('    Old RMS'E14.6'   New RMS='E14.6'   Imp='E14.6)
c
c	check for and invert negative widths
c
	do 2120 k=nbands+1,2*nbands
	ierr=0
	if(params(k).lt.0)ierr=k-nbands
	if(ierr.ne.0)write(*,7422)ierr
	params(k)=abs(params(k))      ! sigma gets squared so keep positive
2120	continue
c
c	check for positive strengths
c
	do 2140 k=2*nbands+1,3*nbands
	ierr=0
	if(params(k).gt.0)ierr=k-(2*nbands)
	if(ierr.ne.0)write(*,7420)ierr
2140	continue
c
7416    format(/'  Improvement in rms less than limit !!')
7418    format(/'  Rms less than limit !!')
c
	if(rmsimp.le.rimplim)write(*,7416)
	if(rmsnew.le.rmslim)write(*,7418)
C	
C	find the diagonals of data info matrix f=g * gnatual inv
C
	temp2=0.0
	do 100 i=1,npnts
	  temp1=0.0
	    do 110 j=1,nparus
c	      temp1=temp1+(g(i,j)*gn(j,i)) 
 110	    continue
	  f(i)=sngl(temp1)
	temp2=temp2+f(i)
 100	continue
c	write(*,112)temp2
c 112	format(/,'  sum of diagonals of data info. matrix:',F12.2) 
c	wropt(-6,2,0)
c	call wrrrn('f',1,npnts,f,1,0)
c
c	display data information
c
c	dmax=0.0
c	do 150 k=2,npnts
c150	dmax=amax1(f(k),dmax)
c	do 300 i=1,npnts
c	  f(i)=f(i)/dmax
c300	continue
c	pmin=ipmin/100.
c	pmax=ipmax/75.
c	do 301 i=1,npnts
c	  f(i)=(f(i)*(pmax-pmin))+pmin
c301	continue
c	call tekon
c	call dgrid(ipmin,ipmax,iwmin,iwmax,
c     &   ivtic,ihtic,lbl,plt)
	icdot=1  !line for data information
	isym=0
c	call dpoints(npnts,wavel,f,isym,icdot,
c     &   ipmin,ipmax,iwmin,iwmax,plt)
	icdot=1
	isym=0
c	call dpoints(npnts,wavel,ratio,isym,icdot,
c     &   ipmin,ipmax,iwmin,iwmax,plt)
c	call dpoints(npnts,wavel,fit,isym,icdot,
c     &   ipmin,ipmax,iwmin,iwmax,plt)
c	call dpoints(npnts,wavel,cont,isym,icdot,
c     &   ipmin,ipmax,iwmin,iwmax,plt)
c	call home
c	call anmode
c	read(*,5001)idum
c5001	format(a1)
c	call tekff
C
C	WAS MORE THAN A ONE TIME FIT SO DO A RERUN
C
	IF(ITIMES.EQ.0)read(*,7022)idum
	IF(ITIMES.EQ.0)RETURN               ! ONE TIME FIT ONLY
7022	format(I1)
C
	if(rmsimp.le.rimplim)READ(*,7022)IDUM
	if(rmsimp.le.rimplim)RETURN    ! IMPROVEMENT LIMIT REACHED
C
	if(rmsnew.le.rmslim)READ(*,7022)IDUM
	if(rmsnew.le.rmslim)RETURN     ! RMS LIMIT REACHED
	GOTO 10                        ! DO IT AGAIN
c
c	if new params are worse apply interpolation factor
c
2402	CONTINUE
	itry=itry+1
	WRITE(*,7414)itry
7414	FORMAT('+',' Applying Binary Backoff to Correction  'I4)
C
	facti=facti/2.0    ! compute interpolation factor
	if(facti.lt.FAILURE)GOTO 5000   ! INTERPOLATION FAILS
c
	NR=0
	DO 2410 K=1,inparam
 	IF(IPSTAT(K,1).NE.0)GOTO 2410                     ! PARAM IS LOCKED
	NR=NR+1
	PARAMS(K)=OLDPAR(K)+(facti*mchs(NR))       ! recalulate
2410	CONTINUE
c
	call unshuffl      
	call fillup
c
	ipts=npnts
	RMSNEW=rmserr(ipts,fit,ratio)  ! get new error
C
	goto 2401                      ! CHECK TO SEE IF WE HAVE A WINNER
C
C	BINARY BACKOFF FAILURE
C
5000	CONTINUE
C
C	RESTORE OLDPAR
C
	DO 4912 K=1,94
	PARAMS(K)=OLDPAR(K)
4912	CONTINUE
	call unshuffl      
	call fillup
C
	WRITE(*,7027)
7027	FORMAT(/'  Interpolation by Binary Backoff Fails !!')
	READ(*,7022)IDUM
	RETURN
C
c
7410	format(7(2X,E15.8))
	END
