c
	real*4 function cgauss(X0,width,zintens,X)
c
c
c
	xdif=x-x0                 ! ROOTS PRECALCULATED
	xsq=xdif*xdif
	sigsq=width
c
	cgauss=zintens*exp(xsq/sigsq)
	return
	end
c
c	double precision version
c
	real*8 function cgaussd(X0,width,zintens,X)
c
	real*8 wconst,sigma,sigsq,xdif,xsq
c
c
	xdif=x-x0
	xsq=xdif*xdif
	sigsq=width
c
	cgaussd=zintens*exp(xsq/sigsq)
	return
	end
c
c	function to convert wavelength in nm to wavenumber in inverse cm
c
	real*4 function wltown(wavel)
c
	wltown=(1.0E7/wavel)
	return
	end
c
c	function to convert wavenumber in inverse cm to wavelength in nm
c
	real*4 function wntowl(waven)
c
	wntowl=(1.0E7/waven)
	return
	end
c
c	single precision version for partial derivatives
c
	real*4 function pgauss(X0,width,zintens,X,ipart)
c
	real*4 X0,x,width,zintens,wconst,sigma,sigsq,xdif,xsq,gtemp
c
c	subroutine to compute partial derivatives of gaussians
c
c	if ipart=1   derivative/center
c	   ipart=2   derivative/width
c	   ipart=3   derivative/intensity
c
c
	xdif=x-x0                ! supplied wave are x**-.2
	xsq=xdif*xdif
	sigma=width
	sigsq=sigma*sigma
c
	goto (100,200,300)ipart
c
c	evaluate partial derivative with respect to center
c
100	pgauss=(xdif/sigsq)*(-1.0*x0**2.0)/1.0E7  ! change magnitude
	return
c
c	evaluate partial derivative with respect to width	
c
200	pgauss=xsq/(sigsq*sigma)
	return
c
c	evaluate partial derivative with respect to strength
c
300	pgauss=1.0/zintens
	return   
	end
c
c	double precision version
c
	real*8 function pgaussd(X0,width,zintens,X,ipart)
c
	real*4 x0,width,zintens,x
	real*8 sigma,sigsq,xdif,xsq,gtemp
c
c	subroutine to compute partial derivatives of gaussians
c
c	if ipart=1   derivative/center
c	   ipart=2   derivative/width
c	   ipart=3   derivative/intensity
c
c	wconst=2.3548200          ! constant to convert fwhm to sigma
c
	xdif=x-x0                ! supplied wave are x**-.2
	xsq=xdif*xdif
	sigma=width
	sigsq=sigma*sigma
c
	goto (100,200,300)ipart
c
c	evaluate partial derivative with respect to center
c
100	pgaussd=(xdif/sigsq)*(-1.0*x0**2.0)/1.0E7  ! change magnitude   
	return
c
c	evaluate partial derivative with respect to width	
c
200	pgaussd=xsq/(sigsq*sigma)
	return
c
c	evaluate partial derivative with respect to strength
c
300	pgaussd=1.0/zintens
	return     
	end
c
c	calculate the root mean square error between two arrays
c
	real*4 function rmserr(npnts,arr1,arr2)
c
	integer*4 npnts
	real*4    arr1(npnts),arr2(npnts)
c
	sum=0.0
c
	do 100 k=1,npnts
	dif=(arr1(k)-arr2(k))
	sqr=dif*dif
	sum=sum+sqr
100	continue
	sum=sum/float(npnts)
	rmserr=sqrt(sum)
	return
	end
